#include        <stdio.h>
#include        <string.h>
#include        "c.h"
#include        "expr.h"
#include        "gen.h"
#include        "cglbdec.h"
#include        "proto.h"

/*
 *      TMS9900 C compiler
 *
 *  Copyright 1990 by LGMA Products
 *
 *  This program is free for you to use for non-commercial purposes.
 *  It is, however, copyrighted so that commercial use is strictly
 *  forbidden.
 *
 *  Please contact:
 *
 *     LGMA PRODUCTS
 *     5618 AppleButter Hill Road
 *     Coopersburg, PA  18036
 *
 *  For suggestions, improvements, and the like.
 *
 */
/* Change History:
**
** Add new revisions to top.
**
**     Who           Date            Reason
**     ===           =========       =======================================
**     ALB           20/DEC/91       Put in some "bail out" fixes, do not hang
**                                   if user doesn't end a brace.
*/

void doinit(sp)
SYM     *sp;
{
int     lab0, genned_label,oldseg;

	oldseg = dseg();	/* initialize into data segment */
	nl();                   /* start a new line in object */
        genned_label = FALSE;

/* generate "EVEN" directive if needed (if even size) */
        geneven((int)sp->tp->size);
        if(sp->storage_class == sc_static) {
                  if ( oldseg ) {
                    lab0 = nextlabel++;
                    put_jump(lab0);
                    genned_label = TRUE;
		  }
                  put_label((int)sp->value.i);
	}else{
                  gen_strlab(sp->name);
	}
        if( lastst != assign) {
                genstorage((int)sp->tp->size);
        }else{
                getsym();
                inittype(sp->tp);
                }
        endinit();
        if ( genned_label ) {
          	gen_label ( lab0 );
	}
}

int     inittype(tp)
TYP     *tp;
{       int     nbytes;
        switch(tp->type) {

                case bt_char:
                        nbytes = initchar();
                        break;
                case bt_short:
                case bt_enum:
                        nbytes = initshort();
                        break;
                case bt_pointer:
                        if( tp->val_flag)
                                nbytes = initarray(tp);
                        else
                                nbytes = initpointer();
                        break;
                case bt_long:
                        nbytes = initlong();
                        break;
                case bt_struct:
                        nbytes = initstruct(tp);
                        break;
                default:
                        error(ERR_NOINIT);
                        nbytes = 0;
                }
        return nbytes;
}

int  initarray(tp)
TYP     *tp;
{       int     nbytes;
        char    *p;
        nbytes = 0;
        if( lastst == begin) {
                getsym();               /* skip past the brace */
                while(lastst != end && lastst != kw_eof ) {
                        nbytes += inittype(tp->btp);
                        if( lastst == comma)
                                getsym();
                        else if( lastst != end )
                                error(ERR_PUNCT);
                        }
                getsym();               /* skip closing brace */
                }
        else if( lastst == sconst && tp->btp->type == bt_char) {
                nbytes = strlen(laststr) + 1;
                p = laststr;
                while( *p )
                        genbyte(*p++);
                genbyte(0);
                getsym();
                }
        else if( lastst != semicolon)
                error(ERR_ILLINIT);
        if( nbytes < tp->size) {
                genstorage( (int) (tp->size - nbytes) );
                nbytes = (int) tp->size;
                }
        else if( tp->size != 0 && nbytes > tp->size)
                error(ERR_INITSIZE);    /* too many initializers */
        return nbytes;
}

int  initstruct(tp)
TYP     *tp;
{       SYM     *sp;
        int     nbytes;

        needpunc(begin);
        nbytes = 0;
        sp = tp->lst.head;      /* start at top of symbol table */
        while(sp != 0) {
                while(nbytes < sp->value.i)    /* align properly */
                        nbytes += genbyte(0);
                nbytes += inittype(sp->tp);
                if( lastst == comma)
                        getsym();
                else if(lastst == end || lastst == kw_eof)
                        break;
                else
                        error(ERR_PUNCT);
                sp = sp->next;
                }
        if( nbytes < tp->size)
                genstorage( (int) (tp->size - nbytes) );
        needpunc(end);
        return tp->size;
}

int  initchar()
{/*       genbyte(intexpr());		*/
	genbyte(constexpr());
        return 1;
}

int  initshort()
{/*	genword(intexpr());		*/
	genword(constexpr());
        return 2;
}

int  initlong()
{/*       genlong(intexpr());		*/
	genlong(constexpr());
        return 4;
}

int  initpointer()
{       SYM     *sp;
        if(lastst == and) {     /* address of a variable */
                getsym();
                if( lastst != id)
                        error(ERR_IDEXPECT);
                else if( (sp =(SYM *) gsearch(lastid)) == 0)
                        error(ERR_UNDEFINED);
                else    {
                        getsym();
                        if( lastst == plus || lastst == minus)
                                genref(sp,intexpr());
                        else
                                genref(sp,0);
                        if( sp->storage_class == sc_auto)
                                error(ERR_NOINIT);
                        }
                }
        else if(lastst == sconst) {
                gen_labref(stringlit(laststr));
                getsym();
                }
        else
                genword(intexpr());
        endinit();
        return 2;       /* pointers are 2 bytes long */
}

void endinit()
{       if( lastst != comma && lastst != semicolon && lastst != end) {
                error(ERR_PUNCT);
                while( lastst != comma && lastst != semicolon && lastst != end
                       && lastst != kw_eof )
                        getsym();
                }
}
