#include        <stdio.h>
#include        "c.h"
#include        "expr.h"
#include        "gen.h"
#include        "cglbdec.h"
#include        "proto.h"

/*
 *      TMS9900 C compiler
 *
 *  Copyright 1990 by LGMA Products
 *
 *  This program is free for you to use for non-commercial purposes.
 *  It is, however, copyrighted so that commercial use is strictly
 *  forbidden.
 *
 *  Please contact:
 *
 *     LGMA PRODUCTS
 *     5618 AppleButter Hill Road
 *     Coopersburg, PA  18036
 *
 *  For suggestions, improvements, and the like.
 *
 */
/* Change History:
**
** Add new revisions to top.
**
**     Who           Date            Reason
**     ===           =========       =======================================
**     ALB           20/DEC/91       Change SP to SPX for debugging purposes.
*/

int  intexpr()       /* simple integer value */
{       int     temp;
        SYM     *spx;

        if(lastst == id) {
                spx =(SYM *) search(lastid,lsyms.head);
                if( spx == NULL)
                        spx =(SYM *) search(lastid,gsyms.head);
                if(spx == NULL) {
                        error(ERR_UNDEFINED);
                        getsym();
                        return 0;
                        }
                if(spx->storage_class != sc_const) {
                        error(ERR_SYNTAX);
                        getsym();
                        return 0;
                        }
                getsym();
                return spx->value.i;

        }else if(lastst == iconst ) {
                temp = (int)ival;
                getsym();
                return temp;

	}else if (lastst == uiconst ) {
                temp = (unsigned int)ival;
                getsym();
                return temp;
	}
        getsym();
        error(ERR_SYNTAX);
        return 0;
}

int constexpr()			/* constant expression analysis */
{   int total, negflag;

    negflag = FALSE;
    if ( lastst == minus ) {	/* if unary minus */
      negflag = TRUE;		/* set negate flag */
      getsym();
    }else if ( lastst == plus ) {
      getsym();
    }
/* get an integer symbol or value using intexpr */
    total = intexpr();
    if ( negflag ) total = -total;

    for ( ;; ) {
      switch ( lastst )	{	/* perform possible arithmetic conversion */
	case plus:
          getsym();
	  total += intexpr();
	  break;
	case minus:
          getsym();
	  total -= intexpr();
	  break;
	case star:
          getsym();
	  total = total * intexpr();
	  break;
	case divide:
          getsym();
	  total = total / intexpr();
	  break;
	default:
	  return total;
      }
    }
}
