#include        <stdio.h>
#include        <string.h>
#include        "c.h"
#include        "expr.h"
#include        "gen.h"
#include        "cglbdec.h"
#include        "proto.h"

/*
 *      TMS9900 C Compiler
 *
 *  Copyright 1990 by LGMA Products
 *
 *  This program is free for you to use for non-commercial purposes.
 *  It is, however, copyrighted so that commercial use is strictly
 *  forbidden.
 *
 *  Please contact:
 *
 *     LGMA PRODUCTS
 *     5618 AppleButter Hill Road
 *     Coopersburg, PA  18036
 *
 *  For suggestions, improvements, and the like.
 *
 */

void put_sc(scl)
int     scl;
{       if ( listflag )
          {
	  switch(scl) {
                case sc_static:
                        fprintf(list,"Static      ");
                        break;
                case sc_auto:
                        fprintf(list,"Auto        ");
                        break;
                case sc_global:
                        fprintf(list,"Global      ");
                        break;
                case sc_external:
                        fprintf(list,"External    ");
                        break;
                case sc_type:
                        fprintf(list,"Type        ");
                        break;
                case sc_const:
                        fprintf(list,"Constant    ");
                        break;
                case sc_member:
                        fprintf(list,"Member      ");
                        break;
                case sc_label:
                        fprintf(list,"Label");
                        break;
                case sc_ulabel:
                        fprintf(list,"Undefined label");
                        break;
                }
	  }
}

void  put_ty(tp)
TYP     *tp;
{       if(tp == 0 || !listflag )
                return;

        switch(tp->type) {
                case bt_char:
                        fprintf(list,"Char");
                        break;
		case bt_void:
			fprintf(list,"Void");
			break;
                case bt_short:
                        fprintf(list,"Short");
                        break;
                case bt_enum:
                        fprintf(list,"enum ");
                        goto ucont;
                case bt_long:
                        fprintf(list,"Long");
                        break;
                case bt_unsigned:
                        fprintf(list,"unsigned ");
                        if ( tp->size == 1 ) {
                           fprintf(list,"char");
                        }else if ( tp->size == 2 ) {
                           fprintf(list,"short");
                        }else{
                           fprintf(list,"long");
			}
                        break;
                case bt_float:
                        fprintf(list,"Float");
                        break;
                case bt_double:
                        fprintf(list,"Double");
                        break;
                case bt_pointer:
                        if( tp->val_flag == 0) {
                                fprintf(list,"Pointer to ");
                        }else{
                                fprintf(list,"Array of ");
			}
                        put_ty(tp->btp);
                        break;
                case bt_union:
                        fprintf(list,"union ");
                        goto ucont;
                case bt_struct:
                        fprintf(list,"struct ");
ucont:                  if(tp->sname == 0)
                                fprintf(list,"<no name> ");
                        else
                                fprintf(list,"%s ",tp->sname);
                        break;
                case bt_ifunc:
                case bt_func:
                        fprintf(list,"Function returning ");
                        put_ty(tp->btp);
                        break;
                }
}

/* list_var : list each variable in the local or global list */
void  list_var(sp,i)
SYM     *sp;
int     i;
{       int     j, k;
	char    su[80];
	if ( listflag ) {
          for(j = i; j; --j)
                fprintf(list,"    ");
          strcpy(su,sp->name);
          for ( k=strlen(sp->name); k<15; k++ )
            su[k] = ' ';
          su[15] = 0;
	  fprintf(list,"%s = %x ",su,sp->value.u);
	}

        if( sp->storage_class == sc_external) {
                strcpy(su,sp->name);
                upcase(su);		/* Convert to upper case */
                if ( copyflag ) {
                  fprintf(copy,  "\tREF\t%s\n",su);
                }else{
                  fprintf(output,"\tREF\t%s\n",su);
		}
	}

        else if( sp->storage_class == sc_global ) {
                strcpy(su,sp->name);
                upcase(su);		/* convert to upper case */
                if ( copyflag ) {
                  fprintf(copy,  "\tDEF\t%s\n",su);
                }else{
                  fprintf(output,"\tDEF\t%s\n",su);
		}
        }

        put_sc(sp->storage_class);
        put_ty(sp->tp);

	if ( listflag )
          fprintf(list,"\n");

        if(sp->tp == 0)
                return;
        if((sp->tp->type == bt_struct || sp->tp->type == bt_union) &&
                sp->storage_class == sc_type)
                list_table(&(sp->tp->lst),i+1);
}

void list_table(t,i)
TABLE   *t;
int     i;
{       SYM     *sp;
        sp = t->head;
        while(sp != NULL) {
                if ( !(t == &lsyms && sp->storage_class == sc_external) ) {
                  list_var(sp,i);
		}
                sp = sp->next;
                }
}
