#include        <stdio.h>
#include        <string.h>
#include        "c.h"
#include        "expr.h"
#include        "gen.h"
#include        "cglbdec.h"
#include        "proto.h"

/*
 *      TMS9900 C Compiler
 *
 *  Copyright 1990 by LGMA Products
 *
 *  This program is free for you to use for non-commercial purposes.
 *  It is, however, copyrighted so that commercial use is strictly
 *  forbidden.
 *
 *  Please contact:
 *
 *     LGMA PRODUCTS
 *     5618 AppleButter Hill Road
 *     Coopersburg, PA  18036
 *
 *  For suggestions, improvements, and the like.
 *
 */

/*      variable initialization         */

enum e_gt { nogen, bytegen, wordgen, longgen };
enum e_sg { noseg, codeseg, dataseg };

enum e_gt gentype = nogen;
enum e_sg curseg  = noseg;

struct oplst {
        char    *s;
        int     ov;
        }       opl[] =
        {	{"A", op_a}, {"AB",op_ab}, {"ABS", op_abs}, {"AI", op_ai},
		{"ANDI", op_andi}, {"B", op_b}, {"BL", op_bl}, 
		{"BLWP", op_blwp}, {"C", op_c}, {"CB", op_cb}, {"CI", op_ci},
		{"CLR", op_clr},
		{"COC", op_coc}, {"CZC", op_czc}, {"DEC", op_dec},
		{"DECT", op_dect}, {"DIV", op_div}, {"DIVS", op_divs},
		{"INC", op_inc}, {"INCT", op_inct}, {"INV", op_inv},
		{"JEQ", op_jeq}, {"JGT", op_jgt}, {"JH", op_jh},
		{"JHE", op_jhe}, {"JL", op_jl},   {"JLE", op_jle},
		{"JLT", op_jlt}, {"JMP", op_jmp}, {"JNC", op_jnc},
		{"JNE", op_jne}, {"JNO", op_jno}, {"JOP", op_jop},
		{"LI", op_li}, {"LIMI", op_limi},
		{"LWPI", op_lwpi}, {"MOV", op_mov},
		{"MOVB", op_movb}, {"MPY", op_mpy}, {"NEG", op_neg},
		{"ORI", op_ori},   {"RTWP", op_rtwp},
		{"S", op_s }, {"SB", op_sb}, {"SBO", op_sbo}, {"SBZ", op_sbz},
		{"SETO", op_seto}, {"SLA", op_sla}, {"SOC",op_soc},
		{"SOCB", op_socb}, {"SRA", op_sra}, {"SRC",op_src},
		{"SRL",op_srl},    {"STST", op_stst},
		{"STWP", op_stwp}, {"SWPB", op_swpb}, {"SZC", op_szc},
		{"SZCB", op_szcb}, {"TB", op_tb}, {"X", op_x}, 
		{"XOP", op_xop}, {"XOR", op_xor}, {"BYTE",op_byte}, 
		{"DATA", op_data}, {"RT", op_rt}, {0,0} };


void  putop(op)
int     op;
{       int     i;
        i = 0;
        while( opl[i].s )
                {
                if( opl[i].ov == op ) {
                        fprintf(output,"\t%s",opl[i].s);
                        return;
                        }
                ++i;
                }
        printf("DIAG - illegal opcode.\n");
}

void putconst(offset)
/*
 *      put a constant to the output file.
 */
struct enode    *offset;
{       char  su[80];
	swap(LOCALIST);
	switch( offset->nodetype )
                {
                case en_autocon:
                case en_icon:
                        fprintf(output,">%x",offset->v.i & 0x0ffff);
                        break;
                case en_labcon:
			fprintf(output,"L%d",offset->v.i);
                        break;
                case en_nacon:
                        strcpy(su,(char *)(offset->v.p[0]));
							/* copy labels str */
                        upcase(su);		     	/* Transform to upper */
                        fprintf(output,"%s",su);
                        break;
                case en_add:
                        putconst(offset->v.p[0]);
                        fprintf(output,"+");
                        putconst(offset->v.p[1]);
                        break;
                case en_sub:
                        putconst(offset->v.p[0]);
                        fprintf(output,"-");
                        putconst(offset->v.p[1]);
                        break;
                case en_uminus:
                        fprintf(output,"-");
                        putconst(offset->v.p[0]);
                        break;
                default:
                        printf("DIAG - illegal constant node %d.\n", 
				offset->nodetype);
                        break;
                }
		swap(PEEPLIST);
}

void putlen(l)
/*
 *      append the length field to an instruction.
 */
int     l;
{       switch( l )
                {
                case 0:
                        break;  /* no length field */
                case 1:
                        fprintf(output,"B");
                        break;
                case 2:
                        fprintf(output," ");
                        break;
                case 4:
                        fprintf(output,"L");
                        break;
                default:
                        printf("DIAG - illegal length field.\n");
                        break;
                }
}

void putamode(ap)
/*
 *      output a general addressing mode.
 */
struct amode    *ap;
{
struct enode    *offset;

        swap ( PEEPLIST );
	switch( ap->mode )
                {
                case am_immed:
			putconst(ap->offset);
			break;
                case am_direct:
			fprintf(output,"@");
                        putconst(ap->offset);
                        break;
		case am_reg:
			fprintf(output,"%d",ap->preg);
			break;
		case am_ind:
			fprintf(output,"*%d",ap->preg);
                        break;
                case am_ainc:
			fprintf(output,"*%d+",ap->preg);
                        break;
		case am_indm:
                        offset = ap->offset;
                        swap ( LOCALIST );
			if ( offset->nodetype == en_icon &&
			     offset->v.i      == 0 ) {
                            swap ( PEEPLIST );
			    fprintf(output,"*%d",ap->preg);
			} else {
			  fprintf(output,"@");
			  putconst(offset);
                          swap ( PEEPLIST );
			  fprintf(output,"(%d)",ap->preg);
			}
			break;
                default:
                        printf("DIAG - illegal address mode.\n");
                        break;
                }
}

void put_code(op,len,aps,apd)
/*
 *      output a generic instruction.
 */
struct amode    *aps, *apd;
enum e_op	op;
int             len;
{       struct  ascode  *asnext;

	if( op == op_byte || op == op_data ) {
		switch( len )
			{
			case 1: fprintf(output,"\tBYTE"); break;
			case 2: fprintf(output,"\tDATA"); break;
			case 4: fprintf(output,"\tDATA,2"); break;
			}
	}else if ( op == op_assy ) {
		asnext = (struct ascode *)aps->offset;
		swap ( ASMLIST );
		while ( asnext != 0 ) {
		  fprintf ( output, "%s", asnext->stmt );
		  asnext = asnext->fwd;
		}
		swap ( PEEPLIST );
		return;

	}else{
		putop(op);
        	putlen(len);
	}
        if( aps != 0 )
                {
                fprintf(output,"\t");
		putamode(aps);
                if( apd != 0 )
                        {
                        fprintf(output,",");
			putamode(apd);
                        }
                }
        fprintf(output,"\n");
}


void putreg(r)
/*
 *      generate a register name from a tempref number.
 */
int     r;
{
		fprintf(output,"%d",r);
}

void gen_strlab(s)
/*
 *      generate a named label.
 */
char    *s;
{
  char su[80];
  strcpy(su,s);			/* Copy the label... */
  upcase(su);			/* Convert to upper case */
  fprintf(output,"%s\n",su);
}

void put_jump(lab)
/*
 *      output a jump around code
 */
int     lab;
{
          fprintf(output,"\tB\t@L%d\n",lab);
}

void put_label(lab)
/*
 *      output a compiler generated label.
 */
int     lab;
{       fprintf(output,"L%d\n",lab);
}

int genbyte(val)
int     val;
{       if( gentype == bytegen && outcol < 60) {
                fprintf(output,",%d",val & 0x00ff);
                outcol += 4;
        }else{
                nl();
                fprintf(output,"\tBYTE\t%d",val & 0x00ff);
                gentype = bytegen;
                outcol = 19;
                }
        return 1;		/* 1 byte per byte */
}

int  genword(val)
int     val;
{       if( gentype == wordgen && outcol < 58) {
                fprintf(output,",>%x",val & 0x0ffff);
                outcol += 6;
                }
        else    {
                nl();
                fprintf(output,"\tDATA\t>%x",val & 0x0ffff);
                gentype = wordgen;
                outcol = 21;
                }
        return 2;            /* 2 bytes per word */
}

int genlong(val)
int     val;
{       
int	wval1, wval2;
	wval1 = ( val >> 16 ) & 0x0000ffff;
	wval2 = val & 0x0000ffff;

	if( gentype == longgen && outcol < 56) {
		fprintf(output,",>%x,>%x",wval1, wval2);
                outcol += 10;
                }
        else    {
                nl();
		fprintf(output,"\tDATA\t>%x,>%x",wval1, wval2);
                gentype = longgen;
                outcol = 25;
                }
        return 4;		/* 4 bytes per longword */
}

void genref(sp,offset)
SYM     *sp;
int     offset;
{       char    sign;
        if( offset < 0) {
                sign = '-';
                offset = -offset;
                }
        else
                sign = '+';
        if( gentype == longgen && outcol < 55 - strlen(sp->name)) {
                if( sp->storage_class == sc_static)
                        fprintf(output,",L%d%c%d",sp->value.i,sign,offset);
                else
                        fprintf(output,",%s%c%d",sp->name,sign,offset);
                outcol += (11 + strlen(sp->name));
                }
        else    {
                nl();
                if(sp->storage_class == sc_static)
                    fprintf(output,"\tDATA\tL%d%c%d",sp->value.i,sign,offset);
                else
                    fprintf(output,"\tDATA\t%s%c%d",sp->name,sign,offset);
                outcol = 26 + strlen(sp->name);
                gentype = longgen;
                }
}

/* geneven - if even # of bytes being output, then force "EVEN" directive */
void geneven ( nbytes )
int     nbytes;
{       if ( (nbytes & 0x1) == 0 ) {
          nl();
          fprintf(output,"\tEVEN\n");
        }
}

/* genstorage - generate the designated # of storage bytes */
void genstorage(nbytes)
int     nbytes;
{       nl();
        fprintf(output,"\tBSS\t%d\n",nbytes);
}

void gen_labref(n)
int     n;
{       if( gentype == longgen && outcol < 58) {
                fprintf(output,",L%d",n);
                outcol += 6;
                }
        else    {
                nl();
                fprintf(output,"\tDATA\tL%d",n);
                outcol = 22;
                gentype = longgen;
                }
}

int     stringlit(s)
/*
 *      make s a string literal and return it's label number.
 */
char    *s;
{       struct slit     *lp;
        ++global_flag;          /* always allocate from global space. */
        lp = (struct slit *)xalloc(sizeof(struct slit));
        lp->label = nextlabel++;
        lp->str = (char *) litlate(s);
        lp->next = strtab;
        strtab = lp;
        --global_flag;
        return lp->label;
}

void dumplits()
/*
 *      dump the string literal pool.
 */
{       char            *cp;
        while( strtab != 0) {
		cseg();
                nl();
                put_label(strtab->label);
                cp = strtab->str;
                while(*cp)
                        genbyte(*cp++);
                genbyte(0);
                strtab = strtab->next;
                }
        nl();
}

void cseg()
{       if( curseg != codeseg) {
                nl();
                fprintf(output,"\tEVEN\n");
                curseg = codeseg;
                }
}

int dseg()
{       if( curseg != dataseg) {
                nl();
                fprintf(output,"\tEVEN\n");
        }
        if ( curseg == codeseg ) {	/* return 1 if code segment */
          curseg = dataseg;
          return 1;
	}else{
          curseg = dataseg;
          return 0;			/* 0 if data segment or no segment */
	}
}

void nl()
{       if(outcol > 0) {
                fprintf(output,"\n");
                outcol = 0;
                gentype = nogen;
                }
}

void upcase(stg)				/* Convert string to upper case */
char *stg;
{ 
  while(*stg) {
    if ( *stg == '_' ) {
      *stg = '#';
    }else{
      *stg = toupper(*stg);
    }
    *stg++;
  }
}


