/*
 *      TMS9900 C Compiler
 *
 *  Copyright 1990 by LGMA Products
 *
 *  This program is free for you to use for non-commercial purposes.
 *  It is, however, copyrighted so that commercial use is strictly
 *  forbidden.
 *
 *  Please contact:
 *
 *     LGMA PRODUCTS
 *     5618 AppleButter Hill Road
 *     Coopersburg, PA  18036
 *
 *  For suggestions, improvements, and the like.
 *
 */

/*  proto.h - function prototypes            */

/* analyze.c */
int             equalnode();
struct cse      *searchnode();
struct enode    *copynode();
struct cse      *enternode();
struct cse      *voidauto();
void            scanexpr();
void            scan();
void            exchange();
int             desire();
int             bsort();
void            allocate();
void            repexpr();
void            repcse();
void            opt1();

/* cmain.c */
void            makename();
void            roptions();
void            aoptions();
void            closefiles();
int             openfiles();
void            summary();
void            init();
void            helpmenu();
int             main();

/* decl.c */
int             imax();
char            *litlate();
TYP             *maketype();
void            decl();
void            decl1();
void            decl2();
int             alignment();
int             declare();
int             declbegin();
void            declenum();
void            enumbody();
void            declstruct();
void            structbody();
void            dodecl();
void            compile();

/* expr.c */
short           highv ();
short           lowv  ();
struct enode    *makenode();
TYP             *deref();
TYP             *nameref();
struct enode    *parmlist();
int             castbegin();
TYP             *primary();
int             lvalue();
TYP             *unary();
TYP             *forcefit();
int             isscalar();
TYP             *multops();
TYP             *addops();
TYP             *shiftop();
TYP             *relation();
TYP             *equalops();
TYP             *binop();
TYP             *bitand();
TYP             *bitxor();
TYP             *bitor();
TYP             *andop();
TYP             *orop();
TYP             *conditional();
TYP             *asnop();
TYP             *exprnc();
TYP             *commaop();
TYP             *expression();

/* func.c */
void            funcbody();
SYM             *makeint();
void            check_table();
void            funcbottom();
void            block();

/* gencode.c */
struct amode    *gen_deref();
struct amode    *gen_asand();
struct amode    *gen_asor();
struct amode    *gen_xbin();
struct amode    *gen_shift();
struct amode    *gen_modiv();
struct amode    *gen_mul();
struct amode    *gen_hook();
struct amode    *gen_asadd();
struct amode    *gen_asshift();
struct amode    *gen_asmodiv();
struct amode    *gen_assign();
struct amode    *gen_aincdec();
struct amode    *gen_expr();
void            gen_compare();
void            truejp();
void            falsejp();

/* genstmt.c */
void            genwhile();
void            gen_for();
void            genif();
void            gendo();
void            call_library();
void            genswitch();
void            gencase();
void            genxswitch();
void            genreturn();
void            genstmt();
void            genfunc();

/* getsym.c */
void           initsym();
int            get_line();
void           getch();
void           error();
int            getid();
int            getsch();
int            radix36();
void           getbase();
void           getfrac();
void           getexp();
void           getnum();
void           getsym();
void           needpunc();

/* init.c */
void           doinit();
int            inittype();
int            initarray();
int            initstruct();
int            initchar();
int            initshort();
int            initlong();
int            initfloat();
int            initdouble();
int            initpointer();
void           endinit();

/* intexpr.c */
int            intexpr();
int            constexpr();

/* list.c */
void           put_sc();
void           put_ty();
void           list_var();
void           list_table();

/* makecode.c */
struct amode    *makedreg();
struct amode    *make_immed();
void            gen_loadr();
void            gen_load();
struct amode    *make_label();
struct amode    *make_labei();
struct amode    *make_offset();
struct amode    *make_limme();
struct amode    *makeireg();
struct amode    *makeareg();
struct amode    *make_direct();
struct amode    *make_strlab();
int             natural_size();
void            make_legal();
void            do_extend();
void            swap_nodes();
void            push_param();
int             gen_parms();
struct amode    *gen_fcall();
struct amode    *gen_unary();
struct amode    *gen_binary();
struct amode    *gen_index();

/* memmgt.c */
#ifndef GENEVE
void            swap();
#endif
char            *xalloc();
void            release_local();
void            release_global();

/* optimize.c */
void            dooper();
int             pwrof2();
int             mod_mask();
void            opt0();
void            fold_const();
int             xfold();
void            opt4();

/* outcode.c */
void            putop();
void            putconst();
void            putlen();
void            putamode();
void            put_code();
void            putreg();
void            gen_strlab();
void            put_jump();
void            put_label();
int             genbyte();
int             genword();
int             genlong();
void            genref();
void            geneven ();
void            genstorage();
void            gen_labref();
int             stringlit();
void            dumplits();
void            cseg();
int             dseg();
void            nl();
void            upcase();

/* peepgen.c */
struct amode    *copy_addr();
void            add_peep();
void            gen_code();
void            gen_1code ();
void            gen_2code ();
void            gen_label();
void            put_ocode();
int             equal_address();
int             used_reg ();
void            removex ();
int             cond_op ();
void            peep_mov();
void            peep_li();
void            peep_ci();
void            peep_ai();
int             det_length ();
int             search_lab ();
void            peep_incdec();
void            peep_uctran();
void            peep_ctran ();
void            opt3();
void            opt5();
void            flush_peep();
int             is_jump();
void            peep_label();
void            opt_labels();
void            removeopcode();

/* preproc.c */
int             isalnum();
int             isidch();
int             isspace();
int             isdigit();
void            shrink();
int             preprocess();
int             doinclude();
int             dodefine();
int             doifdef();
int             doifndef();
int             doendif();
int             doelse();
int             incname();

/* register.c */
int             temp_register();
void            gen_push();
void            gen_pop();
void            initstack();
void            validate();
struct amode    *temp_data();
void            freeop();

/* searchkw.c */
void            searchkw();

/* stmt.c */
struct snode    *asmstmt();
struct ascode   *asmread();
struct snode    *whilestmt();
struct snode    *dostmt();
struct snode    *forstmt();
struct snode    *ifstmt();
struct snode    *casestmt();
int             checkcases();
struct snode    *switchstmt();
struct snode    *retstmt();
struct snode    *breakstmt();
struct snode    *contstmt();
struct snode    *exprstmt();
struct snode    *compound();
struct snode    *labelstmt();
struct snode    *gotostmt();
struct snode    *statement();

/* symbol.c */
SYM            *search();
SYM            *gsearch();
void           insert();
