#include        <stdio.h>
#include        "c.h"
#include        "expr.h"
#include        "gen.h"
#include        "cglbdec.h"
#include        "proto.h"

/*
 *      TMS9900 C Compiler
 *
 *  Copyright 1990 by LGMA Products
 *
 *  This program is free for you to use for non-commercial purposes.
 *  It is, however, copyrighted so that commercial use is strictly
 *  forbidden.
 *
 *  Please contact:
 *
 *     LGMA PRODUCTS
 *     5618 AppleButter Hill Road
 *     Coopersburg, PA  18036
 *
 *  For suggestions, improvements, and the like.
 *
 *  Searchkw is called to examine the last read identifier (lastid) to see
 *  if it is a reserved C keyword.
 *
 *  There are two currently defined search lists :
 *
 *   type 0 - normal defined search list
 *   type 1 - preprocessor reserved word list
 */
#define MAXOPC 27			/* number of opcodes-1 */
#define MIDPOINT MAXOPC/2		/* midpoint of opcodes */

struct kwblk {
        char *word;
        enum e_sym stype;
        };

struct kwblk keywords[] = {
        		{"auto", kw_auto},
			{"break", kw_break},
			{"case", kw_case},
        		{"char", kw_char} ,
			{"continue", kw_continue},
			{"default", kw_default},
        		{"do", kw_do},
			{"double", kw_double},
			{"else", kw_else},
			{"enum", kw_enum},
			{"extern", kw_extern},
			{"float", kw_float},
			{"for", kw_for},
			{"goto", kw_goto},
			{"if", kw_if},
        		{"int", kw_int},
			{"long", kw_long},
			{"register", kw_register},
        		{"return", kw_return},
			{"short", kw_short},
			{"sizeof", kw_sizeof},
			{"static", kw_static},
        		{"struct", kw_struct},
			{"switch", kw_switch},
/*			{"typedef", kw_typedef},		*/
			{"union", kw_union},
			{"unsigned", kw_unsigned},
			{"void", kw_void},
        		{"while", kw_while}
	};

#define PREOPC  8			/* # of preprocessor opcodes */
#define PREMID  PREOPC/2		/* pre-processor opcode midpoint */
struct kwblk prewords[] = {
			{"asm", kw_asm },
                        {"define", kw_define},
                        {"else",  kw_else},
			{"endasm", kw_endasm },
                        {"endif", kw_endif},
                        {"ifdef", kw_ifdef},
                        {"ifndef", kw_ifndef},
                        {"include",kw_include} };
 
void searchkw(typesearch)
int      typesearch;
{
        struct kwblk    *kwbp;
        short  l,r,m,fndkeyw;
/* a binary search is used on the keywords for speed */
/* algorithm from March 1983 Byte Magazine "a faster binary search" */
        l      = 0;
        if ( typesearch == 0 ) {
          r      = MAXOPC;		/* set top & bottom pointers */
          m      = MIDPOINT;
	}else{
          r      = PREOPC;
          m      = PREMID;
	}
	for ( ;; ) {   		/* do while not found or not exhausted */
            if ( typesearch == 0 ) {
              kwbp =  &keywords[m];
	    }else{
              kwbp =  &prewords[m];
	    }
            fndkeyw = strcmp(lastid,kwbp->word);
            if ( fndkeyw == 0 ) {
              lastst = kwbp->stype;
              return;
  	    }else if ( fndkeyw > 0 ) {
              if ( l < r ) {
                l = m+1;
                m = (l+r)/2;
	      }else{
                return;
	      }
	    }else{
              if ( l < r ) {
                r = m;
                m = (l+r)/2;
	      }else{
                return;
	      }
	    }
	}
}
